/* include file to define the FLC file chunks */

#define FLC_MAXFRAMES    4000      /* Max number of frames... */
#define FLCH_MAGIC     0xaf12      /* File header Magic       */
#define FLCF_MAGIC     0xf1fa      /* Frame Magic             */
#define FLC_FINISHED        1
#define FLC_LOOPED          2

typedef struct tagFlc_head{
  long size;
  unsigned short type;             /* = FLCH_MAGIC */
  unsigned short frames;
  unsigned short width;
  unsigned short height;
  unsigned short depth;
  short flags;                      /* set to 0x0003 after ring frame */
  long  speed;
  short reserved1;                  /* set to zero */
  long created;
  long aapro_serial;                /* "FLIB" */
  long date_update;
  long updater;
  short aspectx;
  short aspecty;
  char reserved2[38];
  long oframe1;                     /* offset from file to first ani chunk */
  long oframe2;                     /* offset from file to second ani chunk */
  char reserved3[40];
} Flc_head;

typedef struct tagFlc_frame{
  long size;
  unsigned short type;          /* = 0xf1fa FLCF_MAGIC */
  short chunks;
  char pad[8];
} Flc_frame;

typedef struct tagFlc_chunk{
  long size;
  short type;
} Flc_chunk;

/* types of chunk in a flc_frame */

#define FLC_COLOR256 4
#define FLC_SS2      7
#define FLC_COLOR   11
#define FLC_LC      12
#define FLC_BLACK   13
#define FLC_BRUN    15
#define FLC_COPY    16
#define FLC_PSTAMP  18
