/* include file to define the FLI animation file chunks */

#define FLI_MAXFRAMES (4*1000)     /* Max number of frames... */
#define FLIH_MAGIC     0xaf11      /* File header Magic No    */
#define FLIF_MAGIC     0xf1fa      /* Frame Magic             */
#define FLI_FINISHED        1
#define FLI_LOOPED          2
#define AA_COLOURS        256
#define FLI_CBUF_SIZE   65000

typedef struct tagFli_head
{
  long size;
  unsigned short type;             /* = FLIH_MAGIC */
  unsigned short frame_count;
  unsigned short width;
  unsigned short height;
  unsigned short bits_a_pixel;
  short flags;
  short speed;
  long next_head;
  long frames_in_table;
  short file;           /* used by players.  Contains zeros on disk. */
  long frame1_off;      /* used by players.  Contains zeros on disk. */
  long strokes;         /* how many paint strokes etc. made. */
  long session;         /* stokes since file's been loaded. */
  char reserved[88];    /* all zeroes on disk */
} Fli_head;

typedef struct tagFli_frame
{
  long size;
  unsigned short type;          /* = 0xf1fa FLIF_MAGIC */
  short chunks;
  char pad[8];
} Fli_frame;

typedef struct TagFli_ram_frame
{
 long size;
 unsigned short type;
 short chunks;
 char *frame;
} Fli_ram_frame;

typedef struct tagFli_chunk
{
  long size;
  short type;
} Fli_chunk;

typedef struct tagFli_lc
{
  unsigned short skip;
  unsigned short line;
} Fli_lc;

/* types of chunk in a fli_frame */
#define FLI_COLOR 11
#define FLI_LC    12
#define FLI_BLACK 13
#define FLI_BRUN  15
#define FLI_COPY  16
