/*=========================================================================

  Program:   Visualization Toolkit
  Module:    vtkCyberReader.hh


=========================================================================*/
// .NAME vtkCyberReader - read Cyberware laser digitizer files
// .SECTION Description
// vtkCyberReader is a source object that reads a Cyberware laser digitizer
// file. (Original source code provided courtesy of Cyberware, Inc.)

#ifndef __vtkCyberReader_h
#define __vtkCyberReader_h

#include <stdio.h>
#include "vtkPolySource.hh"

class vtkCyberReader : public vtkPolySource 
{
public:
  vtkCyberReader();
  ~vtkCyberReader();
  char *GetClassName() {return "vtkCyberReader";};
  void PrintSelf(ostream& os, vtkIndent indent);

  // Description:
  // Specify Cyberware file name.
  vtkSetStringMacro(Filename);
  vtkGetStringMacro(Filename);

protected:
  void Execute();
  char *Filename;
};

#endif


