/*=========================================================================

  Program:   Visualization Toolkit
  Module:    vtkPropertyDevice.hh
  Language:  C++
  Date:      09/07/95
  Version:   1.10


Copyright (c) 1993-1995 Ken Martin, Will Schroeder, Bill Lorensen.

This software is copyrighted by Ken Martin, Will Schroeder and Bill Lorensen.
The following terms apply to all files associated with the software unless
explicitly disclaimed in individual files. This copyright specifically does
not apply to the related textbook "The Visualization Toolkit" ISBN
013199837-4 published by Prentice Hall which is covered by its own copyright.

The authors hereby grant permission to use, copy, and distribute this
software and its documentation for any purpose, provided that existing
copyright notices are retained in all copies and that this notice is included
verbatim in any distributions. Additionally, the authors grant permission to
modify this software and its documentation for any purpose, provided that
such modifications are not distributed without the explicit consent of the
authors and that existing copyright notices are retained in all copies. Some
of the algorithms implemented by this software are patented, observe all
applicable patent law.

IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY DERIVATIVES THEREOF,
EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES, INCLUDING,
BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE IS PROVIDED ON AN
"AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE NO OBLIGATION TO PROVIDE
MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.


=========================================================================*/
// .NAME vtkPropertyDevice - abstract definition of a hardware dependent property
// .SECTION Description
// vtkPropertyDevice is the superclass of the hardware dependent Propertys
// such as vtkOglrProperty and vtkSbrProperty. This object is typically created
// automatically by a vtkProperty object when it renders. The user should
// never see this class.

// .SECTION see also
// vtkProperty

#ifndef __vtkPropertyDevice_hh
#define __vtkPropertyDevice_hh

#include "vtkObject.hh"
class vtkRenderer;
class vtkProperty;

class vtkPropertyDevice : public vtkObject
{
public:
  char *GetClassName() {return "vtkPropertyDevice";};

  // Description:
  // This is the only method that the subclasses must supply.
  virtual void Render(vtkProperty *prp, vtkRenderer *ren) = 0;

};

#endif
